rng(42);

ncars = 100;
x = zeros(1,ncars);

for i=1:ncars
    
    bFlag = 1;
    while bFlag
        x_i = round(rand()*999)+1;
        if(~ismember(x_i,x))
            x(i) = x_i;
            bFlag = 0;
        end
    end
    
end

v = zeros(1,ncars);

p = 1.0/3.0;
v_max = 5;

img = ones(1000,1000);
for j=1:ncars
    img(1,x(j)) = 0;
end

for t=2:1000
   v_p = v;
   x_p = x;
   
   for j=1:ncars
      v_j = max([v_p(j) + 1, v_max]);
            
      if (j == ncars)
          a = x_p(1);
          b = x_p(j);
      else
          a = x_p(j+1);
          b = x_p(j);
      end
      
      if(b < a)
          d_j = a - b;
      else
          d_j = 1000 - b + a;
      end
      
      v_j = min([v_j, d_j - 1]);
      
      if(rand() < p)
          v_j = max([0, v_j - 1]);
      end
            
      x(j) = x_p(j) + v_j;
      v(j) = v_j;      
      
      if(x(j) > 1000)
          x(j) = x(j) - 1000;
      end
      
      img(t,x(j)) = 0;
      
   end
   
    
end

imshow(img);