clear all;
rng(42);
n = 10000;

pi_v = zeros(n,1);
for n_i = 1:n
    c_i = 0;
    for j=1:n_i
       p = rand(2,1);
       r = sqrt(sum(p.^2));
       
       if r < 1.0
           c_i = c_i+1;
       end
    end
    t_i = (c_i * 4) / n_i;
    pi_v(n_i) = t_i;
end

plot(1:n,pi_v,[1,n],[pi,pi]);
