function ED = ex_3_interpoint_distance_ghosh(a,b)

as = a^2;
bs = b^2;

ab = sqrt(as+bs);

p1 = 1/15*(a^3/bs + b^3/as + ab * (3 - as/bs - bs/as));
p2 = 1/6 * (bs/a*arcCosh(ab/b)+as/b*arcCosh(ab/a));

ED = p1 + p2;
end

function y = arcCosh(t)
    y = log(t + sqrt(t^2-1));
end
